<?php

namespace App\Http\Controllers;

use App\Models\Password;
use App\Models\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Hash;
use SoapClient;

class UserController extends BaseController
{
    public function LoginRegister(Request $request)
    {
        $mobile = $request->get('mobile',null);
        $mobile = ltrim($mobile,0);
        if($mobile == null || strlen($mobile) < 10 || strlen($mobile) > 10)
            return response()->json($this->SetJsonArray(true,__('text.mobilenumberinvalid')));

        $user = User::where('mobile',$mobile)->first();
        if($user == null)
        {
            $user = User::create([
                'name'=>'u'.$mobile,
                'email'=>'u'.$mobile.'@melorinet.ir',
                'mobile'=>$mobile,
                'password'=>Hash::make(rand(999999,99999999))
            ]);
        }

        $single_password = rand(100000,999999);

        Password::where('user_id',$user->id)->
                  where('status',0)->delete();

        $password = Password::where('user_id',$user->id)->
                              where('status',0)->first();

        if($password == null) {
            $password = Password::create([
                'user_id' => $user->id,
                'password' => $single_password,
                'status' => 1
            ]);
        }

        $client = new SoapClient("http://188.0.240.110/class/sms/wsdlservice/server.php?wsdl");
        $_user = "u09029536609";
        $_pass = "F!#^@12zF!#^@12z";
        $fromNum = "+985000125475";
        $toNum = array($mobile);
        $pattern_code = "jivz42a40qux8sp";
        $input_data = array(
            "single_code" => $password->password
        );
        $reponse_code = $client ->sendPatternSms($fromNum, $toNum, $_user, $_pass, $pattern_code, $input_data);
        if((int) $reponse_code <= 0)
            return response()->json($this->SetJsonArray(true,__('text.sendsmserror')));
        return response()->json($this->SetJsonArray(false,__('text.passwordsentbysms'),['uid'=>$user->id,'mobile'=>$mobile]));
    }

    public function checkPassword(Request $request)
    {
        $mobile = $request->get('mobile');
        $uid = $request->get('uid');
        $password = $request->get('password');

        $user = User::where('id',$uid)->
                      where('mobile',$mobile)->first();

        if($user == null)
            return response()->json($this->SetJsonArray(true,__('text.invalidpassword')));

        $password = Password::where('user_id',$uid)->
                              where('password',$password)->
                              where('status',1)->first();

        if($password == null)
            return response()->json($this->SetJsonArray(true,__('text.invalidpassword')));

        $password->update(['status'=>0]);

        $user = User::find($uid);
        $accessToken = $user->createToken('authToken')->plainTextToken;

        return response()->json($this->SetJsonArray(false,__('text.loginsuccess'),['uid'=>$uid,'name'=>$user->name,'mobile'=>$mobile,'token'=>$accessToken]));
    }
}
